<?php
namespace app\api\controller;

use think\Controller;
use think\Cache;
use think\Db;
define('INTERNAL', 0);

class Index extends Ajax
{
	
    public function playerlist()
    {
		$id=isset($_GET['id'])?$_GET['id']:null;
		if(!$id){
			$this->assign('alert', '页面不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}elseif(model('index/Player')->checkPlayerKey($id)== true){
			$this->assign('alert', '播放器不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}
		$playerModel = model('index/Player');
        // 获取播放器详情
        $player = $playerModel->where("id",$id)->find();
		$tj=model('index/Tj')->where('player_id',$id)->find();
		if(!$tj['id']){
			$tjadd=[
				'uid' => $player['user_id'],
				'player_id' => $player['id'],
				'create_time' => date("Y-m-d H:i:s")
			];
			model('index/Tj')->add($tjadd);
		}else{
			$tjup=[
			    'ci' => $tj['ci']+1,
				'create_time' => date("Y-m-d H:i:s")
			];
			model('index/Tj')->updates($tj['id'],$tjup);
		}
		
         $cache = Cache::get('info'.$id);
        if($cache){
            return response($cache);
        }
        $result = '';
        $result .= "var playerName = '".$player['name']."',";
        $result .= "autoPlayer = ".$player['auto_player'].",";
        $result .= "randomPlayer = ".$player['random_player'].",";
        $result .= "defaultVolume = ".$player['default_volume'].",";
        $result .= "showLrc = ".$player['show_lrc'].",";
        $result .= "greeting = '".$player['greeting']."',";
        $result .= "showGreeting = ".$player['show_greeting'].",";
        $result .= "defaultAlbum = ".$player['default_album'].",";
        $result .= "siteName = '".$player['name']."',";
        $result .= "background = ".$player['background'].",";
        $result .= "playerWidth = ".$player['player_width'].",";
        $result .= "coverWidth = ".$player['cover_width'].",";
        $result .= "showNotes = ".$player['show_notes'].",";
        $result .= "time = ".$player['time'].",";
		$result .= "switchopen = ".$player['switchopen'].",";
		$result .= "showMsg = ".$player['showmsg'].";";
        // 获取播放器歌单

        // 获取歌单歌曲
        $songSheetList = [];
		$songSheets = db('player_song_sheet')
            ->alias('pss')
            ->join('song_sheet ss', 'ss.id=pss.song_sheet_id')
            ->field('ss.*')->where('pss.player_id', $id)
            ->order('pss.taxis asc')
            ->select();
        foreach ($songSheets as $key => $item){
            $songSheetModel = model('index/Song');
            $songs = $songSheetModel->where('song_sheet_id', $item['id'])->order('taxis asc')->select();
            $songIds = [];$songNames = [];$songTypes = [];$albumNames = [];
            $artistNames = [];$albumCovers = [];$locations = [];$lyric = [];
            foreach ($songs as $key2 => $item2){
                $songIds[$key2] = $item2['song_id'];
                $songNames[$key2] = $item2['name'];
                $songTypes[$key2] = $item2['type'];
                $albumNames[$key2] = $item2['album_name'];
                $artistNames[$key2] = $item2['artist_name'];
                $albumCovers[$key2] = $item2['album_cover'];
                $locations[$key2] = $item2['location'];
				$lyric[$key2] = $item2['lyric'];
            }
            $songSheetList[$key] = [
                'songSheetName' => $item['name'],
                'author' => $item['author'],
                'songIds' => $songIds,
                'songNames' => $songNames,
                'songTypes' => $songTypes,
                'albumNames' => $albumNames,
                'artistNames' => $artistNames,
				'albumCovers' => $albumCovers,
                'locations' => $locations,
                'lyric' => $lyric
            ];
        }


        $result .= " songSheetList = ".json_encode($songSheetList);
        // 设置缓存
        Cache::set('info'.$id,$result);
        return response($result);
    }
	
	public function playerinfo()
    {
		$id=isset($_GET['id'])?$_GET['id']:null;
		if(!$id){
			$this->assign('alert', '页面不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}elseif(model('index/Player')->checkPlayerKey($id)== true){
			$this->assign('alert', '播放器不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}
		$playerModel = model('index/Player');
        $player = $playerModel->where("id",$id)->find();
		$tj=model('index/Tj')->where('player_id',$id)->find();
		if(!$tj['id']){
			$tjadd=[
				'uid' => $player['user_id'],
				'player_id' => $player['id'],
				'create_time' => date("Y-m-d H:i:s")
			];
			model('index/Tj')->add($tjadd);
		}else{
			$tjup=[
				'ci' => $tj['ci']+1,
				'create_time' => date("Y-m-d H:i:s")
			];
			model('index/Tj')->updates($tj['id'],$tjup);
		}
         $cache = Cache::get('info2'.$id);
        if($cache){
            return response($cache);
        }
        
        // 获取播放器歌单
		$result =[];
        // 获取歌单歌曲
        $songSheetList = [];
		$songSheets = db('player_song_sheet')
            ->alias('pss')
            ->join('song_sheet ss', 'ss.id=pss.song_sheet_id')
            ->field('ss.*')->where('pss.player_id', $id)
            ->order('pss.taxis asc')
            ->select();
        foreach ($songSheets as $key => $item){
            $songSheetModel = model('index/Song');
            $songs = $songSheetModel->where('song_sheet_id', $item['id'])->order('taxis asc')->select();
            //print_r($songs);exit;
            $songlists = [];
            foreach ($songs as $key2 => $item2){
                $songlists[$key2] = [
                'type' => $item2['type'],
                'id' => $item2['song_id'],
                'name' => $item2['name'],
                'cover' => $item2['album_cover'],
                'artist' => $item2['artist_name'],
                'album' => $item2['album_name'],
				'url' => $item2['location'],
				'lyric' => $item2['lyric'],
            ];
            }
            $songSheetList[$key] = [
                'SheetName' => $item['name'],
                'author' => $item['author'],
                'songs' => $songlists,
            ];
        }
	$result = [
                'playerName' => $player['name'],
                'showGreeting' => $player['show_greeting'],
                'switchopen' => $player['switchopen'],
				'time' => $player['time'],
				'showLrc' => $player['show_lrc'],
				'showMsg' => $player['showmsg'],
				'defaultAlbum' => $player['default_album'],
				'randomPlayer' => $player['random_player'],
				'defaultVolume' => $player['default_volume'],
				'greeting' => $player['greeting'],
				'autoPlayer' => $player['auto_player'],
				'Sheetlist' => $songSheetList,
			];
		$result = json_encode($result);
        // 设置缓存
        /* Cache::set('info2'.$id,$result); */
	echo $_GET['jsoncallback']."(".$result.")";
    }
	
	public function searchSong()
	{
		$type=isset($_GET['type'])?$_GET['type']:null;
		$s=isset($_GET['song_name'])?$_GET['song_name']:null;
		switch ($type) {
            case 'netease':
				$body = $this->encode_netease_data([
                    'method' => 'POST',
                    'url' => 'http://music.163.com/api/cloudsearch/pc',
                    'params' => [
                        's' => $s,
                        'type' => 1,
                        'offset' => 1 * 10 - 10,
                        'limit' => 50
                    ]
                ]);
                $data=get_curl('http://music.163.com/api/linux/forward?eparams='.$body['eparams'],1,'http://music.163.com/');
				$arr=json_decode($data, true);
				$songs = [];
				foreach($arr['result']['songs'] as $value){
					$songs[] = array(
					'song_name' => $value['name'],
					'type' => 'netease',
					'id' => $value['id'],
					'artist_name' => $value['ar'][0]['name']
					);
				}
                break;
            case  'kugou':
                $data=get_curl('http://mobilecdn.kugou.com/api/v3/search/song?keyword='.$s.'&format=json&page=1&pagesize=50',0,'http://m.kugou.com/v2/static/html/search.html');
				$arr=json_decode($data, true);
				$songs = [];
				foreach($arr['data']['info'] as $value){
					$songs[] = array(
					'song_name' => $value['songname'],
					'type' => 'kugou',
					'id' => $value['hash'],
					'artist_name' => $value['singername']
					);
				}
                break;
        }
		$json = json_encode($songs,true);
		echo '{"songs":'.$json.'}';
	}
	
	public function musicUrl()
    {
        $type=isset($_GET['type'])?$_GET['type']:exit;

		$id=isset($_GET['songId'])?$_GET['songId']:null;
		
		
		$json = get_curl(music_api().'?input='.$id.'&filter=id&type='.$type.'&page=1&url='. $_SERVER['SERVER_NAME']);
		$data=json_decode($json,true);

		header('Location: '.$data['url'].'');
		exit;
    }
	
	public function musicLyric()
    {
		
		if($_GET['type']=='local'){

			$id=isset($_GET['id'])?$_GET['id']:null;
			$url=isset($_GET['url'])?$_GET['url']:null;
			$data=get_curl($url);
			$data = Array(
			'file' => 'null',
			'time' => date('Y-m-d h:i:s', time()),
			'type' => 'lrc',
			'txt' => $data
			);
		$json = json_encode($data);
		}else{
		$cache = Cache::get('musicLyric'.$_GET['type'].$_GET['id']);
		$ksc=isset($_GET['ksc'])?$_GET['ksc']:null;
		$headers = get_headers($ksc);
		
		if (strpos($headers[0], '404')) {
		$json = get_curl(music_api().'?input='.$_GET['songId'].'&filter=id&type='.$_GET['type'].'&page=1&url='. $_SERVER['SERVER_NAME']);
		$data=json_decode($json,true);
		$data = Array(
			'file' => 'null',
			'time' => date('Y-m-d h:i:s', time()),
			'type' => 'lrc',
			'txt' => $data['lrc']
			);
		$json = json_encode($data);
		}else{
			$ksctext = get_curl($ksc);
			$data = Array(
			'file' => $ksc,
			'time' => date('Y-m-d h:i:s', time()),
			'type' => 'ksc',
			'txt' => $ksctext
			);
			$json = json_encode($data);
			
		}
		Cache::set('musicLyric'.$_GET['type'].$_GET['id'],$json);
		}
		echo ''.$_GET['jsoncallback'].'('.$json.')';
    }
	
	public function mainColor(){
		$url = $_GET["url"];
        $cache = Cache::get('mainColor'.$url);
        if($cache){
            return response($cache);
        }
        $result = "var cont =";
        if($url != null && $url != ''){
            list($r,$g,$b) = mainColor($url);
            $result .= "'".$r.",".$g.",".$b."'";
            $grayLevel = $r * 0.299 + $g * 0.587 + $b * 0.114;
            if ($grayLevel >= 150) {
                $result .= ";font_color='0,0,0';";
            }else{
                $result .= ";font_color='255,255,255';";
            }
        }else{
            $result .= "'0,0,0';font_color='255,255,255';";
        }

        // 设置缓存
        Cache::set('mainColor'.$url,$result);
        echo $result;
    }
	
	// 加密网易云音乐 api 参数
    public function encode_netease_data($data)
    {
        $_key = '7246674226682325323F5E6544673A51';
        $data = json_encode($data);
        if (function_exists('openssl_encrypt')) {
            $data = openssl_encrypt($data, 'aes-128-ecb', pack('H*', $_key));
        } else {
            $_pad = 16 - (strlen($data) % 16);
            $data = base64_encode(mcrypt_encrypt(
                MCRYPT_RIJNDAEL_128,
                hex2bin($_key),
                $data . str_repeat(chr($_pad), $_pad),
                MCRYPT_MODE_ECB
            ));
        }
        $data = strtoupper(bin2hex(base64_decode($data)));
        return ['eparams' => $data];
    }
}
