<?php
namespace app\index\controller;

use app\index\model\User;
use app\index\model\Player;
use app\index\model\SongSheet;

class Admin extends Common
{
	private $userInfo;
	
	public function _empty()
    {
        return $this->fetch('index/404');
    }
	
	public function index()
    {
		$this->assign('webTitle', '管理中心');
        return $this->fetch();
    }
	
	public function webset()
    {
		$this->assign('webTitle', '网站设置');
        return $this->fetch();
    }
	
	public function msgset()
    {
		if($_GET['gid']){
			$msg = model('Msg')->where('gid',$_GET['gid'])->find();
			$this->assign('msg', $msg);
			$this->assign('webTitle', '消息修改');
			return $this->fetch('admin/msgset');
		}else{
			$msgs = db('msg')
            ->where()
            ->select();
			$this->assign('msgs', $msgs);
			$this->assign('webTitle', '消息列表');
			return $this->fetch('admin/msglist');
		}
		
        
    }
	
	public function userset()
    {
		if($_GET['uid']){
			$user = model('User')->where('uid',$_GET['uid'])->find();
			$userOrders = db('order')
            ->where('uid', $user['uid'])
			->order('id desc')
            ->select();
			$this->assign('user', $user);
			$this->assign('orders', $userOrders);
			$this->assign('webTitle', $user['username'].'-资料修改');
			return $this->fetch('admin/userset');
		}else{
			$users = db('user')
            ->where()
            ->select();
			$this->assign('users', $users);
			$this->assign('webTitle', '用户列表');
			return $this->fetch('admin/userlist');
		}
		
        
    }
	
	public function orderset()
    {
		
		if($_GET['order_number']){
			$order = model('Order')->where('order_number',$_GET['order_number'])->find();
			$this->assign('order', $order);
			$this->assign('webTitle', '订单信息');
			return $this->fetch('admin/orderset');
		}else{
			$orders = db('order')
            ->where()
			->order('id desc')
            ->select();
			$this->assign('orders', $orders);
			$this->assign('webTitle', '订单列表');
			return $this->fetch('admin/orderlist');
		}
    }
	
	protected
    function _initialize()
    {
            $this->checkLogin();
    }

    private
    function checkLogin()
    {
        $check_Login = User::checkLogin();
        if ($check_Login != null) {
            $this->assign('alert', $check_Login['msg']);
            $this->assign('url', $check_Login['url']);
            exit($this->fetch('common/sweetalert'));
        } else {
            $this->userInfo = User::getLoginUser();
            $this->assign('userInfo', $this->userInfo);
			$userInfo = User::getLoginUser();
			if($userInfo['uid']!==1){
			$this->assign('alert', '你没有权限访问这个页面');
            $this->assign('url', url('home/index'));
            exit($this->fetch('common/sweetalert'));
			}
        }
    }
}
