<?php
namespace app\index\controller;

use app\index\model\SongSheet;
use app\index\model\User;
use app\index\model\Player;
use ilt\ImageUtils;
use think\Controller;
use think\Cache;
use think\Db;

class Api extends Common
{
	
    public function info($id){
		if(!$id){
			$this->assign('alert', '页面不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}elseif(model('Player')->checkPlayerKey($id)== true){
			$this->assign('alert', '播放器不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}
        // 读取缓存
        $cache = Cache::get('info'.$id);
        if($cache){
            return response($cache);
        }
        $result = '';
        $playerModel = model('Player');
        // 获取播放器详情
        $player = $playerModel->where("id",$id)->find();
        $result .= "var playerName = '".$player['name']."',";
        $result .= "autoPlayer = ".$player['auto_player'].",";
        $result .= "randomPlayer = ".$player['random_player'].",";
        $result .= "defaultVolume = ".$player['default_volume'].",";
        $result .= "showLrc = ".$player['show_lrc'].",";
        $result .= "greeting = '".$player['greeting']."',";
        $result .= "showGreeting = ".$player['show_greeting'].",";
        $result .= "defaultAlbum = ".$player['default_album'].",";
        $result .= "siteName = '".$player['site_name']."',";
        $result .= "background = ".$player['background'].",";
        $result .= "playerWidth = ".$player['player_width'].",";
        $result .= "coverWidth = ".$player['cover_width'].",";
        $result .= "showNotes = ".$player['show_notes'].",";
        $result .= "autoPopupPlayer = ".$player['auto_popup_player'].";";
        // 获取播放器歌单

        // 获取歌单歌曲
        $songSheetList = [];
		$songSheets = db('player_song_sheet')
            ->alias('pss')
            ->join('song_sheet ss', 'ss.id=pss.song_sheet_id')
            ->field('ss.*')->where('pss.player_id', $id)
            ->order('pss.taxis asc')
            ->select();
        foreach ($songSheets as $key => $item){
            $songSheetModel = model('Song');
            $songs = $songSheetModel->where('song_sheet_id', $item['id'])->order('taxis asc')->select();
            $songIds = [];$songNames = [];$songTypes = [];$albumNames = [];
            $artistNames = [];$albumCovers = [];$locations = [];
            foreach ($songs as $key2 => $item2){
                $songIds[$key2] = $item2['song_id'];
                $songNames[$key2] = $item2['name'];
                $songTypes[$key2] = $item2['type'];
                $albumNames[$key2] = $item2['album_name'];
                $artistNames[$key2] = $item2['artist_name'];
                $albumCovers[$key2] = $item2['album_cover'];
                $locations[$key2] = $item2['location'];
            }
            $songSheetList[$key] = [
                'songSheetName' => $item['name'],
                'author' => $item['author'],
                'songIds' => $songIds,
                'songNames' => $songNames,
                'songTypes' => $songTypes,
                'albumNames' => $albumNames,
                'artistNames' => $artistNames,
                'albumCovers' => $albumCovers
            ];
        }


        $result .= "var songSheetList = ".json_encode($songSheetList);
        // 设置缓存
        Cache::set('info'.$id,$result);
        return response($result);
		
    }


    /**
     * 获取图片主色及字体颜色
     * @param $url string 图片链接
     * @return string script
     */
    public function mainColor($url){
        $cache = Cache::get('mainColor'.$url);
        if($cache){
            return response($cache);
        }
        $result = "var mainColor =";
        if($url != null && $url != ''){
            list($r,$g,$b) = ImageUtils::mainColor($url);
            $result .= "'".$r.",".$g.",".$b."'";
            $grayLevel = $r * 0.299 + $g * 0.587 + $b * 0.114;
            if ($grayLevel >= 150) {
                $result .= ";font_color='0,0,0';";
            }else{
                $result .= ";font_color='255,255,255';";
            }
        }else{
            $result .= "'0,0,0';font_color='255,255,255';";
        }

        // 设置缓存
        Cache::set('mainColor'.$url,$result);
        return response($result);
    }

    /**
     * 获取歌曲
     * @param $type string 歌曲类型
     * @param $songId string 歌曲id
     * @return \think\response\Redirect
     */
    public function musicUrl($type,$songId){
        // 读取缓存
        $cache = Cache::get('music'.$type.$songId);
        if(!$cache){
            $songs = model('Song')->findMusicInfo($type,$songId);
            if ($songs != '' && count($songs) > 0) {
                $song = $songs[0];
                // 设置缓存
                Cache::set('music'.$type.$songId,$song['url'],60*20);
                return redirect($song['url']);
            } else {
                $this->error();
            }
        }else{
            return redirect($cache);
        }

    }

    /**
     * 获取歌词
     * @param $type string 歌曲类型
     * @param $songId string 歌曲id
     * @return \think\Response
     */
    public function musicLyric($type,$songId){
        // 读取缓存
        $cache = Cache::get('musicLyric'.$type.$songId);
        $script = "var lrcstr =''";
        if(!$cache){
            $songs = model('Song')->findMusicInfo($type,$songId);
            if ($songs != '' && count($songs) > 0) {
                $song = $songs[0];
                $lryic = str_replace("\r\n",'',$song['lrc']);
                $lryic = str_replace("\n",'',$lryic);
                $lryic = str_replace("'","\'",$lryic);
                $script = "var lrcstr ='".$lryic."'";
            }
            // 设置缓存
            Cache::set('musicLyric'.$type.$songId,$script);
        }
        return response($cache ? $cache : $script);
    }
}