<?php
namespace app\index\controller;

use app\index\model\User;
use app\index\model\Song;
use app\index\model\Chat;
use app\index\model\Player;
use app\index\model\SongSheet;


class Home extends Common
{
	private $userInfo;
	
	public function _empty()
    {
        return $this->fetch('index/404');
    }
    
    public function QqLoginSet()
	{
		header("Location: https://music.xingyaox.com/qqlogin/api.php?callback=".WebUrl()."/index/home/QqLogin_Callback/uid/".$this->userInfo['uid']);
		exit();
	}
	
	public function QqLogin_Callback($uid)
	{
		$data = $_GET;
		$update['token']=$data['openid'];
		if(!$data['openid'] || !$data['callback']){
				$this->assign('alert', '参数不完整');
				$this->assign('url', url('home/index'));
				exit($this->fetch('common/sweetalert'));
		}elseif(User::checkQqToken($data['openid'])){
				$this->assign('alert', '此QQ已被绑定，如被恶意绑定，请联系管理员');
				$this->assign('url', url('home/index'));
				exit($this->fetch('common/sweetalert'));
		}elseif(User::updateByUid($uid, $update)){
				$this->assign('alert', '绑定成功');
				$this->assign('url', url('home/index'));
				exit($this->fetch('common/sweetalert'));
		}
        return $result;
	}
	
	public function index()
    {
        $ritj=model('Tj')->where('uid',$this->userInfo['uid'])->select();
		$tj=0;
		foreach($ritj as $row){
			$b = substr($row['create_time'],0,10);
			$c = date('Y-m-d');
			if($b==$c){
				$tj=$tj+$row['ci'];
			}
		}
		$this->assign('ritj', $tj);
		$this->assign('webTitle', '用户中心');
        return $this->fetch();
    }
    
	public function chat()
    {
		$chatList = Chat::order('id desc')->limit(10)->select();
        if (!$lastchat = @$chatList[0]['id']) $lastchat = 0;
		$this->assign('lastchat', $lastchat);
		$this->assign('webTitle', '聊天室');
        return $this->fetch();
    }
	
	public function userinfo()
    {
		$this->assign('webTitle', '资料设置');
        return $this->fetch();
    }
	
	public function sheetdt()
    {
		$this->assign('webTitle', '歌单大厅');
        return $this->fetch();
    }
    
	public function shop()
    {
		if(config('codepay') == '0'){
			$this->assign('alert', '站长已关闭本页面');
            $this->assign('url', url('home/index'));
            exit($this->fetch('common/sweetalert'));
		}
		$userInfo = User::getLoginUser();
		$yCode = array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J');
		$str = $yCode[intval(date('Y')) - 2011] . strtoupper(dechex(date('m'))) . date('d') . substr(time(), -5) . substr(microtime(), 2, 5) . sprintf('%02d', rand(0, 99));
		
		$code = uniqid();
		$userOrders = db('order')
            ->where('uid', $userInfo['uid'])
			->order('id desc')
            ->select();
		$this->assign('orders', $userOrders);
		$this->assign('code', $code);
		$this->assign('order_number', $str);
		$this->assign('webTitle', '自助商城');
        return $this->fetch();
    }

    public function playerset($id)
    {
		$key = $id;
		$userInfo = User::getLoginUser();
		if(!$key){
			$this->assign('alert', '页面不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}elseif(Player::checkPlayerKey($key)== true){
			$this->assign('alert', '播放器不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}elseif(Player::checkPlayerUid($key,$userInfo['uid'])== true){
			$this->assign('alert', '你没有权限管理这个播放器');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}else{
			$data = model('Player')->where("id",$key)->find();
        $this->getSide();
        $this->assign('entity', $data);

        // 获取播放器歌单
        $list = Player::songSheets($key);
        $this->assign('selectedSongSheetList', $list);

        // 获取用户的所有歌单
        $userSongSheet = db('song_sheet')
            ->where('user_id', $userInfo['uid'])
            ->select();
		$webSongSheet = db('song_sheet')
            ->where()
            ->select();
        $this->assign('userSongSheet', $userSongSheet);
		$this->assign('webSongSheet', $webSongSheet);
			$this->assign('webTitle', '播放器配置');
			return $this->fetch();
		}
		
    }

    public function sheetset($id)
    {
		$key = $id;
		$userInfo = User::getLoginUser();
		if(!$key){
			$this->assign('alert', '页面不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}elseif(SongSheet::checkSheetKey($key)== true){
			$this->assign('alert', '播放器不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}elseif(SongSheet::checkSheetUid($key,$userInfo['uid'])== true){
			$this->assign('alert', '你没有权限管理这个播放器');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}else{
			
		$entity = model('SongSheet')->where("id",$key)->find();
        $this->assign('entity', $entity);

        // 获取歌单关联歌曲
        $songs = model('Song')->where('song_sheet_id', $key)->order('taxis asc')->select();
        $this->assign('songs', $songs);
		$this->assign('webTitle', '歌单配置');
        return $this->fetch();
		}
    }
	
	public function sheetinfo($id)
    {
		$key = $id;
		$userInfo = User::getLoginUser();
		$entity = model('SongSheet')->where("id",$key)->find();
		if(!$key){
			$this->assign('alert', '页面不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}elseif(SongSheet::checkSheetKey($key)== true){
			$this->assign('alert', '播放器不存在');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
		}elseif($entity['status']=='0'){
			if(SongSheet::checkSheetUid($key,$userInfo['uid'])== true){
			$this->assign('alert', '该歌单没有共享，你无权查看');
            $this->assign('url', url('home/playerlist'));
            exit($this->fetch('common/sweetalert'));
			}
		}else{
		$author = model('User')->where("uid",$entity['user_id'])->find();
        $this->assign('entity', $entity);
		$this->assign('author', $author);

        // 获取歌单关联歌曲
        $songs = model('Song')->where('song_sheet_id', $key)->order('taxis asc')->select();
		$cover = $songs[0]['album_cover'];
		if(httpcode($cover)!=200){
			$cover = '/Static/img/sheet.png';
		}
        $this->assign('songs', $songs);
		$this->assign('cover', $cover);
		$this->assign('webTitle', '歌单配置');
        return $this->fetch();
		}
    }

    public function playerlist()
    {
		$this->assign('webTitle', '播放器列表');
        return $this->fetch();
    }

    public function sheetlist()
    {
		$this->assign('webTitle', '歌单列表');
        return $this->fetch();
    }
	
	public function kscadd()
    {
		$this->assign('webTitle', 'KCS歌词获取');
        return $this->fetch();
    }
	
	protected
    function _initialize()
    {
            $this->checkLogin();
    }

    private
    function checkLogin()
    {
        $check_Login = User::checkLogin();
        if ($check_Login != null) {
            $this->assign('alert', $check_Login['msg']);
            $this->assign('url', $check_Login['url']);
            exit($this->fetch('common/sweetalert'));
        } else {
            $this->userInfo = User::getLoginUser();
            $this->assign('userInfo', $this->userInfo);

        }
    }
}
