<?php
namespace app\index\controller;

use app\index\model\User;

class LoginAjax extends Ajax
{
    private $userInfo;
	public function UserLogin()
	{
		if (request()->isAjax()) {
		    $data = input('post.');
            $rule=[
				'username'  => 'require|alphaDash|length:5,20',
				'password'  => 'require|alphaNum|length:5,20',
			];
			$message=[
				'username.require'=>'<font color="#000000">用户名不能为空</font>',
				'username.length'=>'<font color="#000000">用户名长度必须在5到20之间</font>',
				'password.require'=>'<font color="#000000">密码不能为空</font>',
				'password.alphaNum'=>'<font color="#000000">密码只能字母和数字</font>',
				'password.length'=>'<font color="#000000">密码长度必须在5到20之间</font>',
			];
			$validate=new \think\Validate($rule,$message);
			if(!$validate->check($data)){
				$result = [
						'code' => -1,
						'msg' => $validate->getError()
					];
			}elseif(User::checkUsername($data['username']) == true){
			$result = [
						'code' => -1,
						'msg' => '<font color="#000000">用户名不存在</font>'
					];
			}elseif(User::checkPass($data) == true){
				$result = [
						'code' => -1,
						'msg' => '<font color="#000000">账号或密码错误</font>'
					];
			}elseif(User::checkStatus($data['username']) == false){
				$result = [
						'code' => -1,
						'msg' => '<font color="#000000">此账户已被封禁</font>'
					];
			}elseif(User::login($data)){
					$result = [
						'code' => 0,
						'msg' => '<font color="#000000">登录成功</font>'
					];
			}
        }
        return $result;
	}
	
	public function UserReg()
	{
		if (request()->isAjax()) {
		$data = input('post.');
		$rule=[
            'username'  => 'require|alphaDash|length:5,20',
            'password'  => 'require|alphaNum|length:5,20',
            'qq'    => 'require|number|length:4,13',
        ];
        $message=[
            'username.require'=>'<font color="#000000">用户名不能为空</font>',
            'username.length'=>'<font color="#000000">用户名长度必须在5到20之间</font>',
            'password.require'=>'<font color="#000000">密码不能为空</font>',
            'password.alphaNum'=>'<font color="#000000">密码只能字母和数字</font>',
            'password.length'=>'<font color="#000000">密码长度必须在5到20之间</font>',
            'qq.require'=>"QQ不能为空",
            'qq.number'=>"QQ只能数字",
            'qq.length'=>"QQ长度必须在4到13之间",
        ];
		
        $validate=new \think\Validate($rule,$message);
        if(config('isreg')=='0'){
			$result = [
						'code' => -1,
						'msg' => '<font color="#000000">注册已关闭</font>'
					];
		}elseif(!$validate->check($data)){
			$result = [
						'code' => -1,
						'msg' => $validate->getError()
					];
		}elseif(User::checkUsername($data['username']) != true){
			$result = [
						'code' => -1,
						'msg' => '<font color="#000000">用户名已被注册</font>'
					];
		}elseif(User::checkQq($data['qq']) != true){
        	$result = [
						'code' => -1,
						'msg' => '<font color="#000000">QQ已被其它用户绑定</font>'
					];
        }elseif(User::reg($data)){
					$result = [
						'code' => 0,
						'msg' => '<font color="#000000">注册成功</font>'
					];
			}
		}
        return $result;
    }
	
	public function updatePass()
	{
		if (request()->isAjax()) {
			$userInfo = User::getLoginUser();
			$data = input('post.');
					$result = User::change_Password($userInfo['uid'],$data);
		}
        return $result;
    }
	
	public function Logout()
	{
		if (request()->isAjax()) {
			if(User::logout()){
					$result = [
						'code' => 0,
						'msg' => '<font color="#000000">退出成功</font>'
					];
			}
		}
        return $result;
    }
}