<?php
namespace app\index\model;

use think\Db;
use think\Model;

class Player extends Base
{
	public static function add($data)
    {
        $self = new static();
        $check = $self->insert([
        			'id'=> uniqid(),
					'user_id'=> $data['uid'],
					'name'=> $data['name'],
                    'create_time' => date("Y-m-d H:i:s")]);
        if ($check) {
            return true;
        } else {
            return false;
        }
    }
    /**
     * 获取播放器歌单
     * @param $playerId
     * @return array|\PDOStatement|string|\think\Collection
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\ModelNotFoundException
     * @throws \think\exception\DbException
     */
    public function songSheets($playerId){
        return db('player_song_sheet')
            ->alias('pss')
            ->join('song_sheet ss', 'ss.id=pss.song_sheet_id')
            ->field('ss.*')->where('pss.player_id', $playerId)
            ->order('pss.taxis asc')
            ->select();
    }
	
	public
    static function checkPlayerKey($key)
    {
		$self = new static();
		if(!$row=$self->where("id",$key)->find()){
			return true;
		}else{
			return false;
		}
    }
	
	public
    static function checkPlayerUid($id,$uid)
    {
		$self = new static();
		if(!$row=$self->where("id=:id and user_id=:user_id")->bind(['id'=>$id,"user_id"=>$uid])->find()){
			return true;
		}else{
			return false;
		}
    }
}