<?php
namespace app\index\model;

use think\Cookie;
use think\Model;

class User extends Base
{

    public static function login($userInfo)
    {
        $self = new static();
        cookie("user_token",base64_encode(json_encode(["username"=>$userInfo['username'],"password"=>md5($userInfo['password'])])));
        $update = $self->where('username', '=', $userInfo['username'])
            ->update([
                'last_login_time' => date("Y-m-d H:i:s")
            ]);
        if ($update) {
            return true;
        } else {
            return false;
        }
    }
	
	public static function Qqlogin($data)
    {
        $self = new static();
		$token=$data['openid'];
		$userInfo = $self->where('token', '=' ,$token)->find();
		cookie("user_token",base64_encode(json_encode(["username"=>$userInfo['username'],"password"=>$userInfo['password']])));
        $update = $self->where('uid', '=', $userInfo['uid'])
		->update([
			'last_login_time' => date("Y-m-d H:i:s")
		]);
        if ($update) {
            return true;
        } else {
            return false;
        }
    }
	
	public
    static function checkQqToken($token)
    {
		$self = new static();
		if(!$row=$self->where("token",$token)->find()){
			return false;
		}else{
			return true;
		}
    }
	
	public static function reg($userInfo)
    {
        $self = new static();
        $check = $self->insert([
        			'username'=>$userInfo['username'],
        			'password'=>md5($userInfo['password']),
        			'qq'=>$userInfo['qq'],
					'pie'=>config('reg_pie'),
                    'create_time'=>date("Y-m-d H:i:s"),
                    'create_ip'=>real_ip()
        	]);
        if ($check) {
            return true;
        } else {
            return false;
        }
    }
	
	public
    static function checkUsername($username)
    {
		$self = new static();
		if(!$row=$self->where("username",$username)->find()){
			return true;
		}else{
			return false;
		}
    }
	
	public
    static function checkQq($qq)
    {
		$self = new static();
		if(!$row=$self->where("qq",$qq)->find()){
			return true;
		}else{
			return false;
		}
    }
	
	public
    static function checkPass($userInfo)
    {
		$self = new static();
		if(!$row=$self->where("username=:username and password=:password")->bind(['username'=>$userInfo['username'],"password"=>md5($userInfo['password'])])->find()){
			return true;
		}else{
			return false;
		}
    }
	
	public
    static function checkStatus($username)
    {
		$self = new static();
		$row=$self->where("username",$username)->find();
		if($row['status']==1){
			return true;
		}else{
			return false;
		}
    }
	
	public
    static function checkLogin()
    {
		$user_token = json_decode(base64_decode(cookie("user_token")),true);
        if ($user_token) {
            $self = new static();
            $user = $self
                ->where('username', '=', $user_token['username'])
                ->find();
            if ($user_token['password'] == $user['password']) {
                $result = null;
            } else {
                cookie('user_token', null);
                $result = [
                    'url' => url('index/login'),
                    'msg' => '您的账号信息有改动，请重新登录'
                ];
            }
        } else {
            $result = [
                'url' => url('index/login'),
                'msg' => '未登录'
            ];
        }
        return $result;
    }

    public
    static function delByUid($uid)
    {
        $self = new static();
        if ($result = $self->where('uid', '=', $uid)->delete()) {
            return true;
        } else {
            return false;
        }
    }

    public
    static function updateByUid($uid, $data)
    {
        $self = new static();
        if ($result = $self->where('uid', '=', $uid)->update($data)) {
            return true;
        } else {
            return false;
        }
    }

    public
    static function change_Password($uid, $data)
    {
        $self = new static();
        $rule=[
            'password'  => 'require|alphaNum|length:5,20',
        ];
        $message=[
            'password.require'=>'密码不能为空',
            'password.alphaNum'=>'密码只能字母和数字',
            'password.length'=>'密码长度必须在5到20之间',
        ];
        $validate=new \think\Validate($rule,$message);
        if(!$validate->check($data)){
			$result = [
						'code' => -1,
						'msg' => $validate->getError()
					];
		}else {
            $user_row = $self->where('uid', '=', $uid)->field('password')->find();
            if (md5($data['outpass'])==$user_row['password']) {
                $new_pass = md5($data['password']);
                if ($self->where('uid', '=', $uid)->update(['password' => $new_pass])) {
                    User::logout();
                    $result = [
                        'code' => 0,
                        'msg' => '修改密码成功，请重新登录'
                    ];
                }
            } else {
                $result = [
                    'code' => -1,
                    'msg' => '原密码不正确'
                ];
            }
        }
        return $result;
    }

    public
    static function logout()
    {
        cookie('user_token', null);
        return true;
    }

    public
    static function getLoginUser()
    {
        $self = new static();
        $user_token = json_decode(base64_decode(cookie("user_token")),true);
        //获取登录Cookie
        $username = $user_token['username'];
        //组成查询条件
        $where['username'] = $username;
        //通过Cookie存储的数据查询数据库记录
        if (!$username || !$userInfo = $self->where($where)->find()) {
            //不存在
            return false;
        } else {
            //存在则返回该用户的这条记录内容
            return $userInfo;
        }
    }
}